package com.casic.dcms.ui;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;
import android.view.View;

import androidx.activity.result.ActivityResult;
import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.GridLayoutManager;

import com.casic.dcms.R;
import com.casic.dcms.adapter.NineGridImageAdapter;
import com.casic.dcms.base.AndroidxBaseActivity;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.CaseLargeClassBean;
import com.casic.dcms.bean.CaseSmallClassBean;
import com.casic.dcms.databinding.ActivityUploadCaseQuicklyBinding;
import com.casic.dcms.mvp.presenter.impl.CaseLargeClassPresenterImpl;
import com.casic.dcms.mvp.presenter.impl.CaseSmallClassPresenterImpl;
import com.casic.dcms.mvp.presenter.impl.CaseSubmitPresenterImpl;
import com.casic.dcms.mvp.presenter.impl.UploadImagePresenterImpl;
import com.casic.dcms.mvp.view.ICaseLargeClassView;
import com.casic.dcms.mvp.view.ICaseSmallClassView;
import com.casic.dcms.mvp.view.ICaseSubmitView;
import com.casic.dcms.mvp.view.IUploadFileView;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.OtherUtils;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ToastHelper;
import com.luck.picture.lib.PictureSelector;
import com.luck.picture.lib.config.PictureConfig;
import com.luck.picture.lib.entity.LocalMedia;
import com.luck.picture.lib.tools.PictureFileUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIBottomSheet;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUITipDialog;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class CaseUploadQuicklyActivity extends AndroidxBaseActivity<ActivityUploadCaseQuicklyBinding> implements View.OnClickListener,
        ICaseLargeClassView, ICaseSmallClassView, ICaseSubmitView, IUploadFileView {

    private final Context context = this;
    private CaseLargeClassPresenterImpl caseLargeClassPresenter;
    private CaseSmallClassPresenterImpl caseSmallClassPresenter;
    private CaseSubmitPresenterImpl caseSubmitPresenter;
    private List<CaseLargeClassBean.DataBean> largeClassBeans;
    private List<CaseSmallClassBean.DataBean> smallClassBeans;
    private QMUITipDialog submitDialog;
    private UploadImagePresenterImpl uploadImagePresenter;
    private final ArrayList<String> realPaths = new ArrayList<>();//真是图片路径
    private final List<String> imageList = new ArrayList<>();//上传到服务器的数据集
    private String eorc = "";
    private String typeCode = "";
    private String typeDetailCode = "";//默认值，防止用户不选择直接跳过
    private NineGridImageAdapter imageAdapter;
    private String gridId;

    private final ActivityResultLauncher<Intent> quickCaseLauncher = registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), new ActivityResultCallback<ActivityResult>() {
        @Override
        public void onActivityResult(ActivityResult result) {
            if (result.getResultCode() == Activity.RESULT_OK) {
                Intent data = result.getData();
                if (data == null) {
                    return;
                }
                double longitude = data.getDoubleExtra("longitude", 0);
                double latitude = data.getDoubleExtra("latitude", 0);
                gridId = data.getStringExtra("gridId");
                String community = data.getStringExtra("community");

                viewBinding.longitudeView.setText(String.valueOf(longitude));
                viewBinding.latitudeView.setText(String.valueOf(latitude));
                viewBinding.communityNameView.setText(community);
            }
        }
    });

    @Override
    protected void setupTopBarLayout() {
        viewBinding.titleBarLayout.titleView.setText("快速上报");
        viewBinding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    public void initData() {
        largeClassBeans = new ArrayList<>();
        smallClassBeans = new ArrayList<>();
        caseLargeClassPresenter = new CaseLargeClassPresenterImpl(this);
        caseSmallClassPresenter = new CaseSmallClassPresenterImpl(this);
        caseSubmitPresenter = new CaseSubmitPresenterImpl(this);
        submitDialog = new QMUITipDialog.Builder(this)
                .setIconType(QMUITipDialog.Builder.ICON_TYPE_LOADING)
                .setTipWord("处理中，请稍后")
                .create();
        uploadImagePresenter = new UploadImagePresenterImpl(this);

        imageAdapter = new NineGridImageAdapter(this);
        viewBinding.selectedGridViewView.setLayoutManager(new GridLayoutManager(this, 2));
        viewBinding.selectedGridViewView.setAdapter(imageAdapter);
    }

    @Override
    public void initEvent() {
        viewBinding.caseClassLayout.setOnClickListener(this);
        viewBinding.caseLargeClassLayout.setOnClickListener(this);
        viewBinding.caseSmallClassLayout.setOnClickListener(this);
        viewBinding.locationMapView.setOnClickListener(this);
        viewBinding.submitButton.setOnClickListener(this);
        viewBinding.submitButton.setChangeAlphaWhenPress(true);

        //图片九宫格事件处理
        imageAdapter.setOnItemClickListener(new NineGridImageAdapter.OnItemClickListener() {
            @Override
            public void onAddImageClick() {
                new QMUIDialog.MenuDialogBuilder(context)
                        .addItem("相册中选取", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                OtherUtils.selectPicture(CaseUploadQuicklyActivity.this);
                            }
                        })
                        .addItem("相机拍照", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                                OtherUtils.takePicture(CaseUploadQuicklyActivity.this);
                            }
                        })
                        .create().show();
            }

            @Override
            public void onItemClick(int position) {
                OtherUtils.showBigImage(context, position, realPaths);
            }

            @Override
            public void onItemLongClick(View view, int position) {
                imageList.remove(position);
                imageAdapter.deleteImage(position);
            }
        });
    }

    @Override
    public void onClick(View v) {
        int id = v.getId();
        if (id == R.id.caseClassLayout) {
            new QMUIBottomSheet.BottomListSheetBuilder(this)
                    .setTitle("案卷类型")
                    .addItem("事件")
                    .addItem("部件")
                    .setGravityCenter(true)
                    .setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            viewBinding.caseClassView.setText(tag);
                            viewBinding.caseClassView.setTextColor(ContextCompat.getColor(context, R.color.textColor));

                            //获取案卷大类
                            caseLargeClassPresenter.onReadyRetrofitRequest(String.valueOf(position + 1));
                        }
                    }).build().show();
        } else if (id == R.id.caseLargeClassLayout) {
            if (largeClassBeans != null) {
                if (largeClassBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(this);
                    sheetBuilder.setTitle("案卷大类");
                    for (CaseLargeClassBean.DataBean dataBean : largeClassBeans) {
                        sheetBuilder.addItem(dataBean.getTypeName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            viewBinding.caseLargeClassView.setText(tag);
                            viewBinding.caseLargeClassView.setTextColor(ContextCompat.getColor(context, R.color.textColor));

                            //获取案卷小类
                            CaseLargeClassBean.DataBean dataBean = largeClassBeans.get(position);
                            eorc = dataBean.getEorc();
                            typeCode = dataBean.getTypeCode();
                            String typeId = dataBean.getId();

                            caseSmallClassPresenter.onReadyRetrofitRequest(eorc, typeId);
                        }
                    }).build().show();
                }
            }
        } else if (id == R.id.caseSmallClassLayout) {
            if (smallClassBeans != null) {
                if (smallClassBeans.size() > 1) {
                    QMUIBottomSheet.BottomListSheetBuilder sheetBuilder = new QMUIBottomSheet.BottomListSheetBuilder(this);
                    sheetBuilder.setTitle("案卷小类");
                    for (CaseSmallClassBean.DataBean dataBean : smallClassBeans) {
                        sheetBuilder.addItem(dataBean.getTypeDetailName());
                    }
                    sheetBuilder.setGravityCenter(true).setOnSheetItemClickListener(new QMUIBottomSheet.BottomListSheetBuilder.OnSheetItemClickListener() {
                        @Override
                        public void onClick(QMUIBottomSheet dialog, View itemView, int position, String tag) {
                            dialog.dismiss();
                            viewBinding.caseSmallClassView.setText(tag);
                            viewBinding.caseSmallClassView.setTextColor(ContextCompat.getColor(context, R.color.textColor));

                            typeDetailCode = smallClassBeans.get(position).getTypeDetailCode();
                        }
                    }).build().show();
                }
            }
        } else if (id == R.id.locationMapView) {
            //根据情况加载不同图层
            String type = viewBinding.caseClassView.getText().toString();
            if (type.equals("")) {
                ToastHelper.showToast("请先选择案卷类型", ToastHelper.WARING);
                return;
            }
            Intent intent = new Intent(this, ArcGISMapActivity.class);
            intent.putExtra("type", type);
            quickCaseLauncher.launch(intent);
        } else if (id == R.id.submitButton) {
            submitCase();//案卷提交
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK) {
            switch (requestCode) {
                case PictureConfig.CHOOSE_REQUEST:
                    List<LocalMedia> selectList = PictureSelector.obtainMultipleResult(data);
                    for (LocalMedia media : selectList) {
                        File file = new File(media.getCompressPath());
                        if (file.length() <= Constant.IMAGE_MINUS_SIZE) {
                            ToastHelper.showToast("图片尺寸太小，请重新选择", ToastHelper.ERROR);
                            continue;
                        }
                        uploadImagePresenter.onReadyRetrofitRequest(file);
                    }
                    break;
                case PictureConfig.REQUEST_CAMERA:
                    LocalMedia localMedia = PictureSelector.obtainMultipleResult(data).get(0);
                    uploadImagePresenter.onReadyRetrofitRequest(new File(localMedia.getCompressPath()));
                    break;
                default:
                    break;
            }
        }
    }

    @Override
    public void obtainLargeClassData(CaseLargeClassBean largeClassBean) {
        if (largeClassBean.isSuccess()) {
            //设置大类数据
            this.largeClassBeans = largeClassBean.getData();
            if (largeClassBeans.size() == 0) {
                viewBinding.caseLargeClassView.setText("无小类");
            } else {
                viewBinding.caseLargeClassView.setText(largeClassBeans.get(0).getTypeName());//默认选择第一个
            }
            viewBinding.caseLargeClassView.setTextColor(ContextCompat.getColor(this, R.color.darkGray));

            viewBinding.caseSmallClassView.setText("请选择");
            viewBinding.caseSmallClassView.setTextColor(ContextCompat.getColor(this, R.color.darkGray));
        }
    }

    @Override
    public void obtainSmallClassData(CaseSmallClassBean smallClassBean) {
//        Log.d(TAG, "obtainSmallClassData: " + new Gson().toJson(smallClassBean));
        if (smallClassBean.isSuccess()) {
            //设置大类数据
            this.smallClassBeans = smallClassBean.getData();
            if (smallClassBeans.size() == 0) {
                viewBinding.caseSmallClassView.setText("无小类");
            } else {
                viewBinding.caseSmallClassView.setText(smallClassBeans.get(0).getTypeDetailName());//默认选择第一个
            }
            viewBinding.caseSmallClassView.setTextColor(ContextCompat.getColor(this, R.color.darkGray));
        }
    }

    @Override
    public void showProgress() {
        submitDialog.show();
    }

    @Override
    public void hideProgress() {
        submitDialog.dismiss();
    }

    @Override
    public void obtainUploadAudioResult(ActionResultBean resultBean) {

    }

    @Override
    public void obtainUploadImageResult(ActionResultBean resultBean) {
        if (resultBean.isSuccess()) {
            PictureFileUtils.deleteAllCacheDirFile(this);
            /**
             * 系统路径static拼接图片返回路径
             * http://111.198.10.15:11409/static/2021-04/000bcf78345f4c1c86484efa3f9d68a2.jpeg
             */
            //2021-04\\000bcf78345f4c1c86484efa3f9d68a2.jpeg
            if (imageAdapter.getItemCount() <= 2) {
                String url = resultBean.getData();
                imageList.add(url);
                realPaths.add(StringHelper.appendCompleteURL(url));
                imageAdapter.setupImage(realPaths);
            } else {
                ToastHelper.showToast("最多只能上传2张图片", ToastHelper.WARING);
            }
        }
    }

    @Override
    public void obtainUploadVideoResult(ActionResultBean resultBean) {

    }

    /**
     * 案卷提交
     */
    private void submitCase() {
        String longitude = viewBinding.longitudeView.getText().toString();
        String latitude = viewBinding.latitudeView.getText().toString();
        if (longitude.equals("0") || latitude.equals("0") || TextUtils.isEmpty(longitude) || TextUtils.isEmpty(latitude)) {
            ToastHelper.showToast("经纬度异常，请重新选择位置", ToastHelper.WARING);
            return;
        }
        if (eorc.equals("") || typeCode.equals("")) {
            ToastHelper.showToast("案卷大类还未选择", ToastHelper.WARING);
            return;
        }
        if (typeDetailCode.equals("")) {
            ToastHelper.showToast("案卷小类还未选择", ToastHelper.WARING);
            return;
        }
        if (TextUtils.isEmpty(gridId)) {
            ToastHelper.showToast("网格ID异常，请重新地图选点", ToastHelper.WARING);
            return;
        }
        String fieldIntro = viewBinding.caseLocationView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(fieldIntro)) {
            ToastHelper.showToast("案卷地点还未填写", ToastHelper.WARING);
            return;
        }
        String description = viewBinding.caseDetailEditView.getText().toString().trim().replace(" ", "");
        if (TextUtils.isEmpty(description)) {
            ToastHelper.showToast("案卷情况还未填写", ToastHelper.WARING);
            return;
        }
        if (imageAdapter.getItemCount() != 2) {
            ToastHelper.showToast("必须选择两张图片", ToastHelper.WARING);
            return;
        }
        caseSubmitPresenter.onReadyRetrofitRequest("0", "0", longitude, latitude,
                "1", "1", eorc, typeCode, typeDetailCode,
                gridId.substring(0, 6),
                gridId.substring(0, 9),
                gridId.substring(0, 12),
                gridId, description, fieldIntro,
                StringHelper.reformatURL(imageList), "", "", 0, 0);
    }

    @Override
    public void obtainSubmitResult(ActionResultBean resultBean) {
        if (resultBean.isSuccess()) {
            ToastHelper.showToast("案卷提交成功", ToastHelper.SUCCESS);
            finish();
        } else {
            ToastHelper.showToast("案卷提交失败，请重试", ToastHelper.ERROR);
        }
    }

    @Override
    public void obtainDataFail() {
        ToastHelper.showToast("操作失败", ToastHelper.ERROR);
        //TODO 案卷如果在网络极差的情况下，提交超时导致失败了，需要保存到本地吗？等下次打开的是时候提醒用户补提交之前没提交成功的案卷？
    }

    @Override
    protected void onDestroy() {
        if (caseLargeClassPresenter != null) {
            caseLargeClassPresenter.disposeRetrofitRequest();
        }
        if (caseSmallClassPresenter != null) {
            caseSmallClassPresenter.disposeRetrofitRequest();
        }
        if (caseSubmitPresenter != null) {
            caseSubmitPresenter.disposeRetrofitRequest();
        }
        if (uploadImagePresenter != null) {
            uploadImagePresenter.disposeRetrofitRequest();
        }
        super.onDestroy();
    }
}